=== plugins/in_cpu/CMakeLists.txt ===
set(src
  in_cpu.c)

FLB_PLUGIN(in_cpu "${src}" "")
