=== debian/changelog ===
td-agent-bit (1.2.2) stable; urgency=low

  * Fluent Bit v1.2.2

 -- Eduardo Silva <eduardo@treasure-data.com>  Tue, 16 Jul 2019 11:00:00 -0600

td-agent-bit (1.2.1) stable; urgency=low

  * Fluent Bit v1.2.1

 -- Eduardo Silva <eduardo@treasure-data.com>  Tue, 09 Jul 2019 16:00:00 -0600

td-agent-bit (1.2.0) stable; urgency=low

  * Fluent Bit v1.2.0

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 28 Jun 2019 08:00:00 -0600

td-agent-bit (1.1.3) stable; urgency=low

  * Fluent Bit v1.1.3

 -- Eduardo Silva <eduardo@treasure-data.com>  Thu, 13 Jun 2019 16:00:00 -0600

td-agent-bit (1.1.2) stable; urgency=low

  * Fluent Bit v1.1.2

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 31 May 2019 08:00:00 -0600

td-agent-bit (1.1.1) stable; urgency=low

  * Fluent Bit v1.1.1

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 24 May 2019 08:00:00 -0600

td-agent-bit (1.1.0) stable; urgency=low

  * Fluent Bit v1.1.0

 -- Eduardo Silva <eduardo@treasure-data.com>  Mon, 29 Jan 2019 08:00:00 -0600

td-agent-bit (1.0.6) stable; urgency=low

  * Fluent Bit v1.0.6

 -- Eduardo Silva <eduardo@treasure-data.com>  Wed, 27 Mar 2019 11:00:00 -0600

td-agent-bit (1.0.5) stable; urgency=low

  * Fluent Bit v1.0.5

 -- Eduardo Silva <eduardo@treasure-data.com>  Wed, 20 Mar 2019 11:00:00 -0600

td-agent-bit (1.0.4) stable; urgency=low

  * Fluent Bit v1.0.4

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 01 Feb 2019 08:00:00 -0600

td-agent-bit (1.0.3) stable; urgency=low

  * Fluent Bit v1.0.3

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 18 Jan 2019 08:00:00 -0600

td-agent-bit (1.0.2) stable; urgency=low

  * Fluent Bit v1.0.2

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 11 Jan 2019 08:00:00 -0600

td-agent-bit (1.0.1) stable; urgency=low

  * Fluent Bit v1.0.1

 -- Eduardo Silva <eduardo@treasure-data.com>  Thu, 20 Dec 2018 11:30:00 -0600

td-agent-bit (1.0.0) stable; urgency=low

  * Fluent Bit v1.0.0

 -- Eduardo Silva <eduardo@treasure-data.com>  Mon, 10 Dec 2018 08:00:00 -0600

td-agent-bit (0.14.7) stable; urgency=low

  * Fluent Bit v0.14.7

 -- Eduardo Silva <eduardo@treasure-data.com>  Wed, 07 Nov 2018 08:00:00 -0600

td-agent-bit (0.14.6) stable; urgency=low

  * Fluent Bit v0.14.6

 -- Eduardo Silva <eduardo@treasure-data.com>  Wed, 31 Oct 2018 08:00:00 -0600

td-agent-bit (0.14.5) stable; urgency=low

  * Fluent Bit v0.14.5

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 05 Oct 2018 08:00:00 -0600

td-agent-bit (0.14.4) stable; urgency=low

  * Fluent Bit v0.14.4

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 28 Sep 2018 08:00:00 -0600

td-agent-bit (0.14.3) stable; urgency=low

  * Fluent Bit v0.14.3

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 21 Sep 2018 22:00:00 -0600

td-agent-bit (0.14.2) stable; urgency=low

  * Fluent Bit v0.14.2

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 07 Sep 2018 22:00:00 -0600

td-agent-bit (0.14.1) stable; urgency=low

  * Fluent Bit v0.14.1

 -- Eduardo Silva <eduardo@treasure-data.com>  Thu, 30 Aug 2018 22:00:00 -0600

td-agent-bit (0.14.0) stable; urgency=low

  * Fluent Bit v0.14.0

 -- Eduardo Silva <eduardo@treasure-data.com>  Mon, 02 Jul 2018 22:00:00 -0600

td-agent-bit (0.13.0) stable; urgency=low

  * Based on Fluent Bit v0.13.0

 -- Eduardo Silva <eduardo@treasure-data.com>  Thu, 22 Feb 2018 22:00:00 -0600

td-agent-bit (0.12.19) stable; urgency=low

  * Based on Fluent Bit v0.12.19

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 27 Apr 2018 17:30:00 -0600

td-agent-bit (0.12.18-2) stable; urgency=low

  * Based on Fluent Bit v0.12.18-2

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 20 Apr 2018 17:30:00 -0600

td-agent-bit (0.12.18) stable; urgency=low

  * Based on Fluent Bit v0.12.18

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 20 Apr 2018 11:30:00 -0600

td-agent-bit (0.12.17) stable; urgency=low

  * Based on Fluent Bit v0.12.17

 -- Eduardo Silva <eduardo@treasure-data.com>  Wed, 04 Apr 2018 22:00:00 -0600

td-agent-bit (0.12.16) stable; urgency=low

  * Based on Fluent Bit v0.12.16

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 16 Mar 2018 22:00:00 -0600

td-agent-bit (0.12.15) stable; urgency=low

  * Based on Fluent Bit v0.12.15

 -- Eduardo Silva <eduardo@treasure-data.com>  Tue, 20 Feb 2018 22:00:00 -0600

td-agent-bit (0.12.14) stable; urgency=low

  * Based on Fluent Bit v0.12.14

 -- Eduardo Silva <eduardo@treasure-data.com>  Mon, 12 Feb 2018 22:00:00 -0600

td-agent-bit (0.12.13) stable; urgency=low

  * Based on Fluent Bit v0.12.13

 -- Eduardo Silva <eduardo@treasure-data.com>  Thu, 01 Feb 2018 22:00:00 -0600

td-agent-bit (0.12.12) stable; urgency=low

  * Based on Fluent Bit v0.12.12

 -- Eduardo Silva <eduardo@treasure-data.com>  Wed, 17 Jan 2018 22:00:00 -0600

td-agent-bit (0.12.11) stable; urgency=low

  * Based on Fluent Bit v0.12.11

 -- Eduardo Silva <eduardo@treasure-data.com>  Wed, 20 Dec 2017 22:00:00 -0600

td-agent-bit (0.12.10) stable; urgency=low

  * Based on Fluent Bit v0.12.10

 -- Eduardo Silva <eduardo@treasure-data.com>  Wed, 29 Nov 2017 22:00:00 -0600

td-agent-bit (0.12.9) stable; urgency=low

  * Based on Fluent Bit v0.12.9

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 24 Nov 2017 22:00:00 -0600

td-agent-bit (0.12.8) stable; urgency=low

  * Based on Fluent Bit v0.12.8

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 10 Nov 2017 22:00:00 -0600

td-agent-bit (0.12.7) stable; urgency=low

  * Based on Fluent Bit v0.12.7

 -- Eduardo Silva <eduardo@treasure-data.com>  Wed, 01 Nov 2017 22:00:00 -0600

td-agent-bit (0.12.6) stable; urgency=low

  * Based on Fluent Bit v0.12.6

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 13 Oct 2017 22:00:00 -0600

td-agent-bit (0.12.5) stable; urgency=low

  * Based on Fluent Bit v0.12.5

 -- Eduardo Silva <eduardo@treasure-data.com>  Fri, 06 Oct 2017 22:00:00 -0600

td-agent-bit (0.12.4) stable; urgency=low

  * Based on Fluent Bit v0.12.4


